<!--
Copyright (c) 2021-2024 Henix, Henix.fr

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
-->

# Glossary

## Overview

### channel

**Channel** plugins are plugins that handle communication with _execution environments_.

They process `ExecutionCommand` events and produce `ExecutionResult` events.

### endpoint

An **endpoint** is an exposed API entry point.  It is a URL with an associated
HTTP verb.  The following example describes two endpoints (they are distinct, even
if they share the same URL):

```text
GET https://api.example.com:9876/path/resource
POST https://api.example.com:9876/path/resource
```

### EventBus

An event broker.  It receives _subscriptions_ and _publications_, and dispatches the
publications to interested subscribers.

### elementary command

An **elementary command** is a command an _execution environment_ can run.

`ls -al` or `dir /A` are examples of elementary commands.

### execution environment

An **execution environment** is where the elementary commands are executed.  It can
be a container, a VM, or a physical server.

An execution environment may be tied to a set of _namespaces_.

### function

A **function** is a step item that is converted to a series of steps by _provider_ plugins.

They are used to ease the creation of _workflows_.

### generator

**Generator** plugins are plugins that handle communication with test managers.

They process `GeneratorCommand` events and produce `GeneratorResult` events.

### job

A **job** is either a call to a _generator_ or a sequence of _steps_.  It may
depend on other jobs, in which case it will run after their completion.

### namespace

A **namespace** is a way to group resources.  A _workflow_ belongs to one and only one
namespace (`default` if none is specified), and can only use or access resources that
are part of this namespace, available to this namespace, or available to all namespaces.

### provider

**Provider** plugins are plugins that handle _functions_.

They process `ProviderCommand` events and produce `ProviderResult` events.

### publication

A **publication** is a message that is sent to the _EventBus_.  Services that have
a subscription that matches the publication will receive a copy of this publication.

### publisher

**Publisher** plugins are plugins that handle results and attachments generated by
_execution environments_.

They process `ExecutionResult` events.

### step

A **step** is either an _elementary command_, ready to be sent to an _execution environment_ or
a _function_.

### subscription

A **subscription** is a message sent to the _EventBus_ by a service that describes the
publications the service is interested in.

### workflow

A **workflow** is a collection of _jobs_.
